package ru.amse.bazylevich.faeditor.fautomaton;

import java.util.Set;

public interface IAutomaton {
	
	Set<IState> getStates();
	
	IState getInitialState();
	
	Set<IState> getFinalStates();
	
	void addState(IState state);
	
	void addFinalState(IState state);
	
	void setInitialState(IState state);
	
	void removeState(IState state);
	
	void removeTransition(ITransition transition);
	
	void removeFromFinalStates(IState state);
	
	void toInitialState(IState state);
}
