package ru.amse.bazylevich.faeditor.fautomaton.impl;

import java.util.Collections;
import java.util.LinkedHashSet;
import java.util.Set;

import ru.amse.bazylevich.faeditor.fautomaton.ICondition;

public class Condition implements ICondition {
	private final Set<Character> mySymbols;
	private String myLabel;
	
	public Condition() {
		this(new LinkedHashSet<Character>());
	}
	
	public Condition(Set<Character> set) {
		mySymbols = new LinkedHashSet<Character>(set);
	}
	
	public Condition(CharSequence sequence) {
		this();
		for (int i = 0; i < sequence.length(); i ++) {
			mySymbols.add(sequence.charAt(i));
		}
	}
	
	public Condition(char ch) {
		this();
		mySymbols.add(ch);
	}
	
	public void setSymbols(CharSequence sequence) {
		mySymbols.clear();
		for (int i = 0; i < sequence.length(); i ++) {
			mySymbols.add(sequence.charAt(i));
		}
	}
	

		
	public Set<Character> getSymbols() {
		return Collections.unmodifiableSet(mySymbols);
	}
	
	
	public boolean check(char c) {
		for (Character symbol : mySymbols) {
			if (symbol == c) 
				return true;
		}
		return false;
	}
	
	public String toString() {
		if (myLabel == null) {
			if (mySymbols.size() == 0) {
				myLabel = new String("");
			} else {
				StringBuilder sb = new StringBuilder();
				for (char c : mySymbols) {
					sb.append(c).append(", ");
				}
				sb.deleteCharAt(sb.length() - 1);
				sb.deleteCharAt(sb.length() - 1);
				myLabel = sb.toString();
			}
		}
		return myLabel;
	}
 }
