package ru.amse.bazylevich.faeditor.fautomaton.impl;


import java.util.Collections;
import java.util.LinkedHashSet;
import java.util.Set;
//import java.util.LinkedHashSet;

import ru.amse.bazylevich.faeditor.fautomaton.IState;
import ru.amse.bazylevich.faeditor.fautomaton.ITransition;



public class State implements IState {
	
	private final Set<ITransition> myTransitions;
	private String myLabel;
	
	public State(String label) {
		myTransitions = new LinkedHashSet<ITransition>();
		myLabel = label;
	}
	
	
	public Set<ITransition> getTransitions() {
		return Collections.unmodifiableSet(myTransitions);
	}
	
	public String getLabel() {
		return myLabel;
	}
	
	public void setLabel(String str) {
		myLabel = str;
	}
	
	public void addTransition(ITransition transition) {
		myTransitions.add(transition);
	}
	
	@Override
	public void removeTransition(ITransition transition) {
		myTransitions.remove(transition);
	}
	
	
}
