package ru.amse.bazylevich.faeditor.ui.fautomaton;

import java.awt.Component;
import java.awt.Rectangle;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;

import javax.swing.JComponent;
import javax.swing.JOptionPane;
import javax.swing.JTextField;

import ru.amse.bazylevich.faeditor.ui.fautomaton.util.IParser;
import ru.amse.bazylevich.faeditor.ui.fautomaton.util.Point;
import ru.amse.bazylevich.faeditor.ui.fautomaton.util.exceptions.IncorrectStringException;

public class JLabelEditor extends JTextField {
	
	public final static int MYWIDTH = 20;
	public final static int MYHEIGHT = 80;

	
	private IParser myParser;
	private final JFAutomaton myJFAutomaton; 
	
	public JLabelEditor(JFAutomaton jFAutomaton) {
		myJFAutomaton = jFAutomaton;
		addKeyListener(new JLabelEditorListener());
	}
	
	public void setParser(IParser parser, Point point) {
		myParser = parser;
		setText(myParser.getString());
		setBounds(new Rectangle(point.getX() - MYHEIGHT / 2, point.getY() - MYWIDTH / 2, MYHEIGHT, MYWIDTH));
	}
	
	private class JLabelEditorListener extends KeyAdapter {
		
		@Override
		public void keyPressed(KeyEvent keyEvent) {
			if (keyEvent.getKeyCode() == 10) {
				try {
					myParser.setNewValue(getText());
					JLabelEditor.this.myJFAutomaton.fireComponentChanged();
					delete();
				}
				catch (IncorrectStringException e) {
					JOptionPane.showMessageDialog(JLabelEditor.this.getParent().getParent(), "Please, enter the string again.", "Uncorrect data",JOptionPane.WARNING_MESSAGE);
				}
			} else if (keyEvent.getKeyCode() == 27) {
				delete();
			}
		}
	
		private void delete() {
			Component parent = JLabelEditor.this.getParent();
			((JComponent) parent).remove(JLabelEditor.this);
			parent.repaint();
		}
		
	}

	
}
