package ru.amse.bazylevich.faeditor.ui.fautomaton.file;

import java.util.ArrayList;

import org.xml.sax.Attributes;
import org.xml.sax.SAXException;
import org.xml.sax.helpers.DefaultHandler;

import ru.amse.bazylevich.faeditor.fautomaton.IState;
import ru.amse.bazylevich.faeditor.ui.fautomaton.IAutomatonPresentation;
import ru.amse.bazylevich.faeditor.ui.fautomaton.IStatePresentation;
import ru.amse.bazylevich.faeditor.ui.fautomaton.impl.StatePresentation;

public class AutomatonPresentationLoaderHandler extends DefaultHandler {
	private final IAutomatonPresentation myAutomatonPresentation;
	private final ArrayList<IState> myStates;
	private int myIndex;
	
	public AutomatonPresentationLoaderHandler(IAutomatonPresentation automatonPresentation) {
		myAutomatonPresentation = automatonPresentation;
		myStates = new ArrayList<IState>(myAutomatonPresentation.getAutomaton().getStates());
		myIndex = 0;
	}
	
	
	
	@Override
	public void startElement(String uri, String localName, String name,	Attributes attributes) throws SAXException {
		if (name.equals("presentation")) {
			if (myIndex < myStates.size()) {
				IStatePresentation sPresentation = new StatePresentation(myStates.get(myIndex), new Integer(attributes.getValue("x")), new Integer(attributes.getValue("y")));
				myAutomatonPresentation.addStatePresentation(sPresentation);
				myIndex++;
			}
		}
	}
	
	public void endDocument() throws SAXException {
		myStates.clear();
		myIndex = 0;
	}

}
