package ru.amse.bazylevich.faeditor.ui.fautomaton.tools.impl;

import java.awt.Graphics;
import java.awt.event.MouseEvent;

import ru.amse.bazylevich.faeditor.ui.fautomaton.IStatePresentation;
import ru.amse.bazylevich.faeditor.ui.fautomaton.JFAutomaton;
import ru.amse.bazylevich.faeditor.ui.fautomaton.tools.ITool;
import ru.amse.bazylevich.faeditor.ui.fautomaton.util.AutomatonPresentatios;
import ru.amse.bazylevich.faeditor.ui.fautomaton.util.Point;

public class AddTool implements ITool {
	
	private final JFAutomaton myJFAutomaton;
	private ITool myTool;
	
	public AddTool(JFAutomaton jFAutomaton) {
		myJFAutomaton = jFAutomaton;
		myTool = new AddVertexState(jFAutomaton);
	}
	
	@Override
	public void mouseClicked(MouseEvent event) {
		if (event.getClickCount() == 1) {
			if (myJFAutomaton.getComponentCount() != 0) {
				if (event.getSource() == myJFAutomaton) {
					myJFAutomaton.removeAll();
				}
			}
		}
		myTool = new AddVertexState(myJFAutomaton);
		myTool.mouseClicked(event);
		myTool = new AddVertexState(myJFAutomaton);
		myJFAutomaton.repaint();
	}
	
	@Override
	public void mouseDragged(MouseEvent event) {
		myTool.mouseDragged(event);
		
	}
	
	@Override
	public void mousePressed(MouseEvent event) {
		Point point = new Point(event.getX(), event.getY());
		IStatePresentation state = AutomatonPresentatios.searchSideState(point, myJFAutomaton.getAutomatonPresentation());
		if (state == null) {
			myTool = new AddVertexState(myJFAutomaton);
		} else {
			myTool = new AddTransitionState(myJFAutomaton, state);
		}
		myTool.mousePressed(event);
		
	}
	
	@Override
	public void mouseReleased(MouseEvent event) {
		myTool.mouseReleased(event);
		myTool = new AddVertexState(myJFAutomaton);
		myJFAutomaton.repaint();
	}
	
	@Override
	public void finishDrawing(Graphics gc) {
		myTool.finishDrawing(gc);
	}
	
	@Override
	public void mouseMoved(MouseEvent event) {
		myTool.mouseMoved(event);
	}

}
