package ru.amse.bazylevich.faeditor.ui.fautomaton.tools.impl;

import java.awt.Graphics;
import java.awt.event.MouseEvent;

import ru.amse.bazylevich.faeditor.fautomaton.ITransition;
import ru.amse.bazylevich.faeditor.ui.fautomaton.IStatePresentation;
import ru.amse.bazylevich.faeditor.ui.fautomaton.JFAutomaton;
import ru.amse.bazylevich.faeditor.ui.fautomaton.tools.ITool;
import ru.amse.bazylevich.faeditor.ui.fautomaton.util.AutomatonPresentatios;
import ru.amse.bazylevich.faeditor.ui.fautomaton.util.Point;
import ru.amse.bazylevich.faeditor.ui.fautomaton.util.impl.StateLabelParser;
import ru.amse.bazylevich.faeditor.ui.fautomaton.util.impl.TransitionParser;

public class ChangeLabelState implements ITool {
	
	private final JFAutomaton myJFAutomaton;
	
	
	public ChangeLabelState(JFAutomaton jFAutomaton) {
		myJFAutomaton = jFAutomaton;
	}
	
	@Override
	public void mouseClicked(MouseEvent mEvent) {
		Point point = new Point(mEvent.getX(), mEvent.getY());
		ITransition transition = AutomatonPresentatios.getTransition(myJFAutomaton.getAutomatonPresentation(), point);
		if (transition != null) {
			myJFAutomaton.getLabelEditor().setParser(new TransitionParser(transition), point);
			myJFAutomaton.add(myJFAutomaton.getLabelEditor());
			myJFAutomaton.getLabelEditor().requestFocusInWindow();
		} else {
			IStatePresentation state = AutomatonPresentatios.searchStatePresentation(myJFAutomaton.getAutomatonPresentation(), point);
			if (state != null) {
				myJFAutomaton.getLabelEditor().setParser(new StateLabelParser(state.getState()), point);
				myJFAutomaton.add(myJFAutomaton.getLabelEditor());
				myJFAutomaton.getLabelEditor().requestFocusInWindow();
			}
		}
	}
	
	@Override
	public void mouseDragged(MouseEvent event) {
		// TODO Auto-generated method stub
		
	} 
	
	@Override
	public void mousePressed(MouseEvent event) {
		// TODO Auto-generated method stub
		
	}
	
	@Override
	public void mouseReleased(MouseEvent event) {
		// TODO Auto-generated method stub
		
	}
	
	@Override
	public void finishDrawing(Graphics gc) {
		// TODO Auto-generated method stub
		
	}
	
	@Override
	public void mouseMoved(MouseEvent event) {
		// TODO Auto-generated method stub
		
	}
	

}
