package ru.amse.bazylevich.faeditor.ui.fautomaton.tools.impl;

import java.awt.Graphics;
import java.awt.event.MouseEvent;
import java.util.Set;


import ru.amse.bazylevich.faeditor.ui.fautomaton.IStatePresentation;
import ru.amse.bazylevich.faeditor.ui.fautomaton.JFAutomaton;
import ru.amse.bazylevich.faeditor.ui.fautomaton.tools.ITool;
import ru.amse.bazylevich.faeditor.ui.fautomaton.util.AutomatonPresentatios;
import ru.amse.bazylevich.faeditor.ui.fautomaton.util.Point;

public class MoveVertexState implements ITool {
	
	private final JFAutomaton myJFAutomaton;
	private Point myDraggedPoint;

	public MoveVertexState(JFAutomaton jFAutomaton) {
		myJFAutomaton = jFAutomaton;
	}
	
	@Override
	public void mouseClicked(MouseEvent mEvent) {
	}
	
	@Override
	public void mousePressed(MouseEvent mEvent) {
		myJFAutomaton.setSelectedTransition(null);
		Point point = new Point(mEvent.getX(), mEvent.getY());
		IStatePresentation state = AutomatonPresentatios.searchStatePresentation(myJFAutomaton.getAutomatonPresentation(),point);
		Set<IStatePresentation> set = myJFAutomaton.getSelectedStates();
		if (set.isEmpty()) {
			set.add(state);
			myDraggedPoint = point;
		} else if (!set.contains(state)) {
			set.clear();
		} else {
			myDraggedPoint = point;
		}
		if (myJFAutomaton.getSelectedStates().size() != 0) {
			myJFAutomaton.fireElementsSelected();
		} else {
			myJFAutomaton.fireElementsUnselected();
		}
	}
	
	@Override
	public void mouseDragged(MouseEvent mEvent) {
		myJFAutomaton.fireComponentChanged();
		for (IStatePresentation sPresentation : myJFAutomaton.getSelectedStates()) {
			moveSelectedStates(sPresentation, mEvent);
		}
		myDraggedPoint = new Point(mEvent.getX(), mEvent.getY());
	}
	
	@Override
	public void mouseReleased(MouseEvent event) {
		myDraggedPoint = null;
		myJFAutomaton.getSelectedStates().clear();
		myJFAutomaton.fireElementsUnselected();
		myJFAutomaton.repaint();
		
	}
	
	
	public void finishDrawing(Graphics gc) {
		
	}
	

	private void  moveSelectedStates(IStatePresentation sPresentation, MouseEvent mEvent) {
		sPresentation.setX(sPresentation.getX() + mEvent.getX() - myDraggedPoint.getX());
		sPresentation.setY(sPresentation.getY() + mEvent.getY() - myDraggedPoint.getY());

	}

	@Override
	public void mouseMoved(MouseEvent event) {
		// TODO Auto-generated method stub
		
	}

}
