package ru.amse.bazylevich.faeditor.ui.fautomaton.tools.impl;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.event.MouseEvent;

import ru.amse.bazylevich.faeditor.fautomaton.ITransition;
import ru.amse.bazylevich.faeditor.ui.fautomaton.IStatePresentation;
import ru.amse.bazylevich.faeditor.ui.fautomaton.JFAutomaton;
import ru.amse.bazylevich.faeditor.ui.fautomaton.draw.impl.AutomatonDrawer;
import ru.amse.bazylevich.faeditor.ui.fautomaton.draw.util.Geometry;
import ru.amse.bazylevich.faeditor.ui.fautomaton.tools.ITool;
import ru.amse.bazylevich.faeditor.ui.fautomaton.util.Point;

public class SelectTransitionState implements ITool {

	private final JFAutomaton myJFAutomaton;
	private final ITransition myTransition;
	
	public SelectTransitionState(JFAutomaton jFAutomaton, ITransition transition) {
		myJFAutomaton = jFAutomaton;
		myTransition = transition;
		myJFAutomaton.fireElementsSelected();
	}
	
	
	@Override
	public void finishDrawing(Graphics gc) {
		ITransition transition =  myJFAutomaton.getSelectedTransition();
		if (transition != null) {
			drawSelectionTransition(gc);
		}
	}
	
	private void drawSelectionTransition(Graphics gc) {
		IStatePresentation start = myJFAutomaton.getAutomatonPresentation().getMapStatesPresentation().get(myJFAutomaton.getSelectedTransition().getStart());
		IStatePresentation end = myJFAutomaton.getAutomatonPresentation().getMapStatesPresentation().get(myJFAutomaton.getSelectedTransition().getEnd());
		Point startRectangleVertex;
		Point endRectangleVertex;
		if (start != end) {
			Point startPoint = new Point(start.getX(), start.getY());
			Point endPoint = new Point(end.getX(), end.getY());
			Point newStart = Geometry.computingEdgeEnd(startPoint, endPoint);
			Point newEnd = Geometry.computingEdgeEnd(endPoint, startPoint);
			startRectangleVertex = new Point(newStart.getX() - JFAutomaton.MYWIDTH / 2, newStart.getY() - JFAutomaton.MYWIDTH / 2);
			endRectangleVertex = new Point(newEnd.getX() - JFAutomaton.MYWIDTH / 2, newEnd.getY() - JFAutomaton.MYWIDTH / 2);
		} else {
			startRectangleVertex = new Point(start.getX() - JFAutomaton.MYWIDTH, start.getY() - AutomatonDrawer.MYSTATEHEIGHT / 2 - JFAutomaton.MYWIDTH /2);
			endRectangleVertex = new Point(start.getX(), start.getY() - AutomatonDrawer.MYSTATEHEIGHT / 2 - JFAutomaton.MYWIDTH /2);
		}
		gc.setColor(Color.GRAY);
		gc.fillRoundRect(startRectangleVertex.getX(), startRectangleVertex.getY(), JFAutomaton.MYWIDTH, JFAutomaton.MYWIDTH, JFAutomaton.MYWIDTH / 2, JFAutomaton.MYWIDTH / 2);
		gc.fillRoundRect(endRectangleVertex.getX(), endRectangleVertex.getY(), JFAutomaton.MYWIDTH, JFAutomaton.MYWIDTH, JFAutomaton.MYWIDTH / 2, JFAutomaton.MYWIDTH / 2);
		gc.setColor(Color.BLACK);
	}




	@Override
	public void mouseClicked(MouseEvent event) {
		myJFAutomaton.setSelectedTransition(myTransition);
	}

	@Override
	public void mouseDragged(MouseEvent event) {
		// TODO Auto-generated method stub

	}

	@Override
	public void mousePressed(MouseEvent event) {
		// TODO Auto-generated method stub

	}

	@Override
	public void mouseReleased(MouseEvent event) {
		// TODO Auto-generated method stub

	}
	
	@Override
	public void mouseMoved(MouseEvent event) {
		// TODO Auto-generated method stub
		
	}

}
