package ru.amse.bazylevich.faeditor.ui.menuactions;

import java.awt.event.ActionEvent;

import javax.swing.AbstractAction;

import ru.amse.bazylevich.faeditor.fautomaton.IAutomaton;
import ru.amse.bazylevich.faeditor.fautomaton.algorithms.TransformerFAutomaton;
import ru.amse.bazylevich.faeditor.main.MainFrame;
import ru.amse.bazylevich.faeditor.ui.fautomaton.JFAutomaton;
import ru.amse.bazylevich.faeditor.ui.fautomaton.impl.AutomatonPresentation;
import ru.amse.bazylevich.faeditor.ui.fautomaton.util.AutomatonPresentatios;

public class DetermineAction extends AbstractAction {
	
	private final JFAutomaton myJFAutomaton;
	private final MainFrame myMainFrame;
	
	public DetermineAction(JFAutomaton jFAutomaton, MainFrame mainFrame) {
		super("Determine");
		myJFAutomaton = jFAutomaton;
		myMainFrame = mainFrame;
	}
	
	@Override
	public void actionPerformed(ActionEvent e) {
		myJFAutomaton.fireComponentChanged();
		if (myMainFrame.showSaveDialog(e)) {
			IAutomaton automaton = TransformerFAutomaton.toDeterminate(myJFAutomaton.getAutomatonPresentation().getAutomaton());
			myJFAutomaton.setAutomaton(new AutomatonPresentation(automaton, AutomatonPresentatios.makeStatePresentations(automaton)));
			myMainFrame.setAsked();
			myJFAutomaton.repaint();
		}
	}

}
