package ru.amse.bazylevich.faeditor.ui.menuactions;

import java.awt.event.ActionEvent;
import java.io.IOException;

import javax.swing.AbstractAction;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;

import org.xml.sax.SAXException;

import ru.amse.bazylevich.faeditor.main.MainFrame;
import ru.amse.bazylevich.faeditor.ui.fautomaton.JFAutomaton;
import ru.amse.bazylevich.faeditor.ui.fautomaton.file.IAutomatoPresentationnLoader;


public class OpenAction extends AbstractAction {
	
	private IAutomatoPresentationnLoader myLoader;
	private final JFileChooser myFileChooser;
	private final MainFrame myMainFrame;
	private final JFAutomaton myJFAutomaton;
	
	
	public OpenAction(MainFrame mainFrame, JFAutomaton jAutomaton, IAutomatoPresentationnLoader loader, JFileChooser chooser) {
		super("Open");
		myFileChooser = chooser;
		myJFAutomaton = jAutomaton;
		myMainFrame = mainFrame;
		myLoader = loader;
	}
	
	public void actionPerformed(ActionEvent e) {
		if (myLoader != null) {
			if (myMainFrame.showSaveDialog(e)) {
				myFileChooser.setApproveButtonText("Open");
				myFileChooser.setDialogTitle("Open");
				int res = myFileChooser.showOpenDialog(myMainFrame);
				if ( res == JFileChooser.APPROVE_OPTION ) {
					try {
						myJFAutomaton.setAutomaton(myLoader.load(myFileChooser.getSelectedFile()));
						myJFAutomaton.remove(myJFAutomaton.getLabelEditor());
						if (myMainFrame.getCurrentFile() != null) {
							myMainFrame.setPreviosFile(myMainFrame.getCurrentFile());
						}
						myMainFrame.setCurrentFile(myFileChooser.getSelectedFile());
						myJFAutomaton.fireComponentChanged();
						myMainFrame.setNormalTitle();
						} catch (IOException exception) {
							JOptionPane.showMessageDialog(myMainFrame, "File can't be opened. Probably the program haven't access to it.", "Warning" ,JOptionPane.WARNING_MESSAGE);
							fileProcessing(e);
						} catch (SAXException exeption) {
							JOptionPane.showMessageDialog(myMainFrame, "Contents of file doesn't correspond to expected. Probably file was damaged.", "Warning" ,JOptionPane.WARNING_MESSAGE);
							fileProcessing(e);
						}
				} else if (res == JFileChooser.CANCEL_OPTION) {
					myMainFrame.setAsked();
				}
			}
		}
	}
	
	private void fileProcessing(ActionEvent e) {
		if (myMainFrame.getCurrentFile() != null) {
			myFileChooser.setSelectedFile(myMainFrame.getCurrentFile());
		} else if (myMainFrame.getPreviousFle() != null) {
			myFileChooser.setSelectedFile(myMainFrame.getPreviousFle());
		}
		if (myMainFrame.getCurrentFile() != null) {
			myMainFrame.setPreviosFile(myMainFrame.getCurrentFile());
		}
		myMainFrame.setCurrentFile(null);
		actionPerformed(e);

	}

}
